<?php
/**
* Plugin PostCardViewer pour SPIP v.0.1
* par Manu T'J (manu AT tjampens.com)
*
* Copyright (c) 2008
* Logiciel libre distribue sous licence GNU/GPL.
*
**/

if (!defined("_ECRIRE_INC_VERSION")) return;

function balise_PCV($p){	
	if (!$idg = interprete_argument_balise(1,$p)) {
		$idg = champ_sql('id_article', $p);
	}
	$p->code = "pvc_creation_xml($idg)";
	$p->interdire_scripts = false;
	return $p;
}

function pvc_creation_xml($id_galerie) {
	// -----------------------
	// DEBUT DES OPTIONS
	$options .= '<GALLERY_DATA cellDimension="'._PCV_CELLDIMENSION.'" columns="'._PCV_NBCOLUMNS.'" zoomOutPerc="15" zoomInPerc="100" frameWidth="15" frameColor="'._PCV_FRAMECOLOR.'" captionColor="'._PCV_CAPTIONCOLOR.'" enableRightClickOpen="'._PCV_ENABLERIGHTCLICKOPEN.'">';
	// FIN DES OPTIONS
	// -----------------------
	
	// Requete (attention au prefixe des tables -> a revoir)
	$req = "SELECT titre, fichier, descriptif FROM spip_documents WHERE id_document IN ( SELECT id_document FROM spip_documents_liens WHERE id_objet = ".$id_galerie." AND objet = 'article' ) ORDER BY titre;";
	$result = spip_query($req);
	
	// Traitement
	$xml = '<?xml version="1.0" encoding="UTF-8" ?>'.$options;
	while ($row = spip_fetch_array($result))
	{
		$titre = $row['titre'];
		$chemin = $row['fichier'];
		$descriptif = $row['descriptif'];
		
		$xml .= "\n<image>\n";
		$xml .= "<url>"._NOM_PERMANENTS_ACCESSIBLES.$chemin."</url>\n";
		
		if ($descriptif <> "") {
			$xml .= "<caption><![CDATA[<u><a href='".$descriptif."' target='_blank'>".$titre."</a></u>]]></caption>\n";
		} else {
			$xml .= "<caption>".$titre."</caption>\n";
		}
		
		$xml .= "</image>\n";
	}
	$xml .= '</gallery>';
	
	// On ecrit le fichier
	$file = _DIR_PLUGIN_PCV."xml/gallery_".$id_galerie.".xml"; 
	if (file_exists($file)) unlink($file);
	if (!$file_handle = fopen($file,"w")) { 
		spip_log("[PCV] Impossible d'ouvrir le fichier : ".$file); 
	}  elseif (!fwrite($file_handle, $xml)) { 
		spip_log("[PCV] Impossible d'ecrire dans le fichier : ".$file);   
	}else{
		spip_log("[PCV] Creation reussie du fichier : ".$file);   
	}
	fclose($file_handle);
	
	// On balance le code HTML...
	return '<div id="flashcontent">PostcardViewer pour SPIP n&eacute;cessite JavaScript et <a href="http://www.macromedia.com/go/getflashplayer/">le lecteur Flash</a>.</div>
	<script type="text/javascript">
	var fo = new SWFObject("'._DIR_PLUGIN_PCV.'pcv_viewer.swf", "pcv_viewer", "'._PCV_WIDTH.'", "'._PCV_HEIGHT.'", "8", "'._PCV_BGCOLOR.'");		
			
	//Optional Configuration
	fo.addParam("wmode", "'._PCV_WMODE.'");
	fo.addVariable("langOpenImage", "Ouvrir l\'image dans une nouvelle fen&ecirc;tre");
	fo.addVariable("langAbout", "A propos de");	
	fo.addVariable("xmlURL", "'._DIR_PLUGIN_PCV.'xml/gallery_'.$id_galerie.'.xml");					

	fo.write("flashcontent");	
	</script>';
}

?>

